<script lang="ts" setup>
import NavBarButton from "@/components/navbar/NavBarButton.vue";
import ModalView from "@/components/ModalView.vue";
import WhiskeyLogo from "@/components/WhiskeyLogo.vue";
import SunMoonButton from "@/components/ui/SunMoonButton.vue";
import { reactive } from "vue";
import { onBeforeRouteLeave } from "vue-router/dist/vue-router";
import { useRouter } from "vue-router";
import { useSessionStore } from "@/stores/session";

const router = useRouter();
const isAdmin = useSessionStore().isAdmin();

const state = reactive({
  displayMenu: false,
});

onBeforeRouteLeave(() => {
  state.displayMenu = false;
});
</script>

<template>
  <nav
    id="nav"
    class="flex justify-flex-start bg-theme-background-accent md:pr-3"
  >
    <WhiskeyLogo
      :scale="1.1"
      class="cursor-pointer"
      @click="router.push('/')"
    />
    <NavBarButton to="/dashboard">Dashboard</NavBarButton>
    <NavBarButton to="/units">Unités</NavBarButton>
    <NavBarButton to="/users">Annuaire</NavBarButton>
    <NavBarButton to="/groups">Groupes</NavBarButton>
    <NavBarButton v-if="isAdmin" to="/admin">Administration</NavBarButton>
    <span class="flex-grow hidden small-navbar:block"></span>
    <NavBarButton class="small-navbar:mr-5" to="/my-account">
      Mon Compte
    </NavBarButton>
    <SunMoonButton class="justify-self-end ml-auto"></SunMoonButton>
    <NavBarButton
      class="block small-navbar:hidden flex flex-col justify-center justify-self-end mr-3"
      menu
      @click="state.displayMenu = !state.displayMenu"
    >
      <svg
        height="24"
        viewBox="0 0 32 32"
        width="24"
        xml:space="preserve"
        xmlns="http://www.w3.org/2000/svg"
        xmlns:xlink="http://www.w3.org/1999/xlink"
      >
        <path
          d="M26,16c0,1.104-0.896,2-2,2H8c-1.104,0-2-0.896-2-2s0.896-2,2-2h16C25.104,14,26,14.896,26,16z"
        />
        <path
          d="M26,8c0,1.104-0.896,2-2,2H8c-1.104,0-2-0.896-2-2s0.896-2,2-2h16C25.104,6,26,6.896,26,8z"
        />
        <path
          d="M26,24c0,1.104-0.896,2-2,2H8c-1.104,0-2-0.896-2-2s0.896-2,2-2h16C25.104,22,26,22.896,26,24z"
        />
      </svg>
    </NavBarButton>

    <ModalView
      v-model="state.displayMenu"
      slide-right
      @click="state.displayMenu = false"
    >
      <div class="flex flex-col">
        <router-link :to="{ name: 'dashboard' }" class="side-link"
          >Dashboard
        </router-link>
        <router-link :to="{ name: 'units' }" class="side-link"
          >Unités
        </router-link>
        <router-link :to="{ name: 'users' }" class="side-link"
          >Annuaire
        </router-link>
        <router-link :to="{ name: 'groups' }" class="side-link"
          >Groupes
        </router-link>
        <router-link v-if="isAdmin" :to="{ name: 'admin' }" class="side-link"
          >Administration
        </router-link>
        <router-link :to="{ name: 'my-account' }" class="side-link"
          >Mon Compte
        </router-link>
      </div>
    </ModalView>
    <!--    <sun-moon-button light></sun-moon-button>-->
  </nav>
</template>

<style scoped>
svg path {
  fill: var(--theme-text);
}

svg circle {
  fill: var(--theme-text);
}

.side-link {
  padding: 8px;
}

.side-link:hover {
  background-color: var(--theme-text-link-hover);
}

.router-link-active.side-link,
.router-link-active.side-link:hover {
  background-color: transparent;
  cursor: default;
  color: var(--theme-text-darker);
}
</style>
